{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}


//////////////////////////////////////////////////
// Copyright (c) 2002 by venom, VENOM Software. //
// All rights reserved.                         //
// Visit me at http://www.venomsoftware.de      //
//////////////////////////////////////////////////




UNIT VGFX_Extra;


INTERFACE



USES     VGFX;



{---------------------------------------------------------------------------}

 FUNCTION  CalculateLine      (x1,y1,x2,y2:LongInt):LongInt;
 FUNCTION  CalculateDetailLine(x1,y1,x2,y2:LongInt):LongInt;

{---------------------------------------------------------------------------}





IMPLEMENTATION


CONST   Copyright = 'Copyright (c) 2002 by venom, VENOM Software. All rights reserved.';




{---------------------------------------------------------------------------}


FUNCTION CalculateLine(x1,y1,x2,y2:LongInt):LongInt;
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 CalculateLine:= 1;
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:= abs(x1-x2);
 yDIFF:= abs(y1-y2);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   Inc(CalculateLine);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   Inc(CalculateLine);
  end;
 end;
End;


FUNCTION CalculateDetailLine(x1,y1,x2,y2:LongInt):LongInt;
VAR      xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 CalculateDetailLine:= 1;
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:= abs(x1-x2);
 yDIFF:= abs(y1-y2);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(CalculateDetailLine);
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   Inc(CalculateDetailLine);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(CalculateDetailLine);
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   Inc(CalculateDetailLine);
  end;
 end;
End;


(******************************** INIT UNIT *********************************)


BEGIN

END.

