{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}


//////////////////////////////////////////////////
// Copyright (c) 2002 by venom, VENOM Software. //
// All rights reserved.                         //
// Visit me at http://www.venomsoftware.de      //
//////////////////////////////////////////////////




UNIT VGFX_Files;


INTERFACE




USES     Windows,Sysutils,
         Bigfile2,
         VGFX_Errors,
         VGFX;






FUNCTION    File2Mem     (Datei         :String; var Target:Pointer):Longint;
FUNCTION BigFile2Mem     (Datei,BigDatei:String; var Target:Pointer):Longint;

FUNCTION FileSpr2Mem     (Datei         :String; var Target:Pointer;var BreiteHoehe:Longint):Longint;
FUNCTION BigFileSpr2Mem  (Datei,BigDatei:String; var Target:Pointer;var BreiteHoehe:Longint):Longint;





{---------------------------------------------------------------------------}




IMPLEMENTATION



CONST  Copyright = 'Copyright (c) 2002 by venom, VENOM Software. All rights reserved.';









FUNCTION File2Mem(Datei:String; var Target:Pointer):Longint;
VAR      Dat     : File;
Begin
 Assign(Dat,Datei);
 {$I-}
 Reset(Dat,1);
 {$I+}
 If IOResult<>0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'File : '+Datei);

 File2Mem:= FileSize(Dat);

 Target:= Nil;
 AllokPtrSpeicher(Target,FileSize(Dat));

 BlockRead(Dat,Target^,FileSize(Dat));
 Close(Dat);
End;



FUNCTION BigFile2Mem(Datei,BigDatei:String; var Target:Pointer):Longint;
VAR      BigDat,Error : Byte;
         Dat          : Word;
Begin
 BigDat:= BIGOPEN(BigDatei);
 If BigDat>244 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Internal error message : '+#13+ErrorString(BigDat)+#13+#13+'File : '+BigDatei);
  Dat:= OpenFile(BigDat,Datei);

   If Dat=0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Error occured while open sub file "'+Datei+'" of main file "'+BigDatei+'" ! ');

   BigFile2Mem:= SizeFile(BigDat,Dat);

   Target:= Nil;
   AllokPtrSpeicher(Target,Sizefile(BigDat,Dat));

   Error:= ReadBig(BigDat,Dat,Target,Sizefile(BigDat,Dat));

   If Error<>0 then ERRORM('I/O Error !','An error occured when trying to load sub file "'+Datei+'" from main file "'+BigDatei+'" ! ');

  CloseFile(BigDat,Dat);
 BigClose(BigDat);
End;



{---------------------------------------------------------------------------}



FUNCTION FileSpr2Mem(Datei:String; var Target:Pointer;var BreiteHoehe:Longint):Longint;
VAR      Dat : File;
Begin
 Assign(Dat,Datei);
 {$I-}
 Reset(Dat,1);
 {$I+}
 If IOResult<>0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'File : '+Datei);

 FileSpr2Mem:= FileSize(Dat);

 Target:= Nil;
 AllokPtrSpeicher(Target,FileSize(Dat)-4);

 BlockRead(Dat,           Target^,FileSize(Dat)-4);
 BlockRead(Dat,Addr(BreiteHoehe)^,              4);
 Close(Dat);
End;



FUNCTION BigFileSpr2Mem(Datei,BigDatei:String; var Target:Pointer;var BreiteHoehe:Longint):Longint;
VAR      BigDat,Error : Byte;
         Dat          : Word;
Begin
 BigDat:= BIGOPEN(BigDatei);
 If BigDat>244 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Internal error message : '+#13+ErrorString(BigDat)+#13+#13+'File : '+BigDatei);
  Dat:= OpenFile(BigDat,Datei);

   If Dat=0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Error occured while open sub file "'+Datei+'" of main file "'+BigDatei+'" ! ');

   BigFileSpr2Mem:= SizeFile(BigDat,Dat);

   Target:= Nil;
   AllokPtrSpeicher(Target,Sizefile(BigDat,Dat));

   Error:= ReadBig(BigDat,Dat,Target,Sizefile(BigDat,Dat)-4);
   If Error<>0 then ERRORM('I/O Error !','An error occured when trying to load sub file "'+Datei+'" from main file "'+BigDatei+'" ! ');

   Error:= ReadBig(BigDat,Dat,Addr(BreiteHoehe),          4);
   If Error<>0 then ERRORM('I/O Error !','An error occured when trying to load sub file "'+Datei+'" from main file "'+BigDatei+'" ! ');

  CloseFile(BigDat,Dat);
 BigClose(BigDat);
End;


(******************************** INIT UNIT *********************************)


BEGIN

END.

